function A = numbering_matrix_one(m,n)

% This function will give back the optimal tour for n or m even with radius 1
% given in a matrix A.

% Case m is even, n is even or odd:

% Construct A:

if mod(m,2) == 1 && mod(n,2) == 1
    error('m or n has to be even!')
end

% Now the case for m = 3, m != n and n mod 2 = 0:

if m == 3 || n == 3
    if n == 3
    error('n has to be greater than m!')
    end
    
    A = zeros(m,n);
    B = zeros(m,n);
    count = 1;
    
    A([1 3],2) = [count,count+2];
    A(2,1) = count+1;
    count = count+3;
    
    A(2,3:2:n-1) = count:2:count+2*length(3:2:n-1)-2;
    A(3,4:2:n) = count+1:2:count+2*length(4:2:n)-1;
    count = count+2*length(4:2:n)-1+1;

    A(1,n:-2:4) = count:(m*n)/2;
    
    %even vertices:
 
    count = m*n;
    A(3,1) = count;
    count = count-1;
    
    A(1,1:2:n-1) = count:-2:count-2*length(1:2:n-1)+2;
    A(2,2:2:n) = count-1:-2:count-2*length(2:2:n)+1;
    count = count-2*length(2:2:n)+1-1;
    
    A(3,n-1:-2:3) = count:-1:count-length(n-1:-2:3)+1;
    return
end

% Start with filling rows 1,2 and then clockwise continuing to make full
% the first circle.

% If n is odd m has to be even, to implement that the only thing to be done
% is to rotate the matrix, therfore change m and n:

he = false;
if mod(m,2) == 1 && mod(n,2) == 0
    c = m;
    m = n;
    n = c;
    he = true;
end

A = zeros(m,n);

count = 1;
 
if mod(n,2)==0
    
    %This is the case that the matrix has a even number of columns:
    %I start in field (2,1) and number the first two rows then the last
    %two columns then the last two rows and at last the first two columns
    %(clockwise).
    
    A(1,2:2:n) = count+1:2:count+2*length(2:2:n)-1;
    A(2,1:2:n) = count:2:count+2*length(1:2:n)-2;
    
    count = count+2*length(2:2:n)-1+1;
    A(3:2:m-1,n) = count:2:count+2*length(3:2:m-1)-2;
    A(4:2:m,n-1) = count+1:2:count+2*length(4:2:m)-1;
    
    count = count+2*length(4:2:m)-1+1;
    A(m-1,n-2:-2:2) = count:2:count+2*length(n-2:-2:2)-2;
    A(m,n-3:-2:1) = count+1:2:count+2*length(n-3:-2:1)-1;
    
    count = count+2*length(n-3:-2:1)-1+1;
    A(m-2:-2:4,1) = count:2:count+(m/2-3)*2;
    A(m-3:-2:3,2) = count+1:2:count+(m/2-3)*2+1;
   
    count = count+(m/2-3)*2+1+1;
    
else
    %In the case that n is odd it is just a matter of changing the indizes
    
    A(1,2:2:n-1) = count+1:2:count+2*length(2:2:n-1)-1;
    A(2,1:2:n) = count:2:count+2*length(1:2:n)-2;
    
    count = count+2*length(1:2:n)-2+1;
    A(3:2:m-1,n-1) = count:2:count+2*length(3:2:m-1)-2;
    A(4:2:m,n) = count+1:2:count+2*length(4:2:m)-1;
    
    count = count+2*length(4:2:m)-1+1;
    A(m,n-2:-2:1) = count:2:count+2*length(n-2:-2:1)-2;
    A(m-1,n-3:-2:2) = count+1:2:count+2*length(n-3:-2:1)-1;
    
    count = count+2*length(n-2:-2:1)-2+1;
    A(m-2:-2:4,1) = count:2:count+(m/2-3)*2;
    A(m-3:-2:3,2) = count+1:2:count+(m/2-3)*2+1;
    
    count = A(3,2)+1;  
end

m1 = 4;
x = true;

while m1 <= m-2,
    
    if mod(n,2) == 0
        %to the right: start in m1,3
        if x
        A(m1,3:2:n-3) = count:2:count+2*length(3:2:n-3)-2;
        A(m1-1,4:2:n-2) = count+1:2:count+2*length(4:2:n-2)-1;
        count = count+2*length(4:2:n-2)-1+1;
        x = false;
        
        %to the left: start in m1-1, n-2
        else
        A(m1-1,n-2:-2:4) = count:2:count+2*length(n-2:-2:4)-2;
        A(m1,n-3:-2:3) = count+1:2:count+2*length(n-3:-2:3)-1;
        count = count+2*length(n-3:-2:3)-1+1;
        x = true;
        end
        
        m1 = m1+2;
        
    else
        if x
        A(m1,3:2:n-2) = count:2:count+2*length(3:2:n-2)-2;
        A(m1-1,4:2:n-3) = count+1:2:count+2*length(4:2:n-3)-1;
        count = count+2*length(3:2:n-2)-2+1;
        x = false;
        
        else
        A(m1-1,n-3:-2:4) = count+1:2:count+2*length(n-3:-2:4)-1;
        A(m1,n-2:-2:3) = count:2:count+2*length(n-2:-2:3)-2;
        count = count+2*length(n-2:-2:3)-2+1;
        x = true;
        end
        
        m1 = m1+2;
        
    end
        
end



% Next step is to number the even vertices:

if (mod(m,4) == 0) %mirrow after m/2
    
    B = A(1:3,1:n);
    B = flipud(B);
    C = A(4:m,1:n);
    C = flipud(C);
    B = [C;B];
    
    count = A(m-2,3)+1;
    set = count-1;
    
    for i = 1:set,
        [row,col] = find(B == i);
        B(row,col) = count;
        count = count+1;
    end
    A = A+B;
    
elseif mod(m,4) == 2 && mod(n,2) == 1 && m >= 6 %rotate 180 deg
    
    count = max(A(:))+1;
    set = count-1;
    
    B = A;
    B = imrotate(B,180);
    
    for i = 1:set,
        [row,col] = find(B == i);
        B(row,col) = count;
        count = count+1;
    end

    A = A+B; 

elseif m == 6 && mod(n,2) == 0 %mirrow after n/2
   
    B = A(1:m,1:n/2);
    B = fliplr(B);
    C = A(1:m,n/2+1:n);
    C = fliplr(C);
    B = [C,B];
    
    count = A(m-3,n-2)+1;
    set = count-1;
    
    for i = 1:set,
            [row,col] = find(B == i);
            B(row,col) = count;
            count = count+1;
    end
    
    A = A+B;

elseif mod(m,4) == 2 && mod(n,2) == 0 && m >= 8
    
    B = zeros(size(A));
    count = 1;
    
    %start at (1,3) zigzag in rows 1 and 2
    B(1,3:2:n-1) = count:2:count+2*length(3:2:n-1)-2;
    B(2,4:2:n) = count+1:2:count+2*length(4:2:n)-1;
    count = count+2*length(4:2:n)-1+1;
    
    %zigzag in column n,n-1
    B(3:2:m-1,n-1) = count:2:count+2*length(3:2:m-1)-2;
    B(4:2:m,n) = count+1:2:count+2*length(4:2:m)-1;
    count = count+2*length(4:2:m)-1+1;
    
    %zigzag in row m,m-1
    B(m,n-2:-2:2) = count:2:count+2*length(n-2:-2:2)-2;
    B(m-1,n-3:-2:1) = count+1:2:count+2*length(n-3:-2:1)-1;
    count = count+2*length(n-3:-2:1)-1+1;
    
    %zigzag in column 1,2 end in (3,1)
    B(m-2:-2:4,2) = count:2:count+2*length(m-2:-2:4)-2;
    B(m-3:-2:3,1) = count+1:2:count+2*length(m-3:-2:3)-1;
    count = count+2*length(m-3:-2:3)-1+1;
    
    
    for i = 1:3,
    B(i,i) = count;
    count = count+1;
    end
    
    B(4,4:2:n-2) = count:2:count+2*length(4:2:n-2)-2;
    B(3,5:2:n-3) = count+1:2:count+2*length(5:2:n-3)-1;
    count = count+2*length(4:2:n-2)-2+1;
    
    m1 = 6;
    x = true;
    
    while m1 <= m-6,
        
        %nach links: fngt bei m1 an
        if x == 1
        B(m1,n-2:-2:4) = count:2:count+2*length(n-2:-2:4)-2;
        B(m1-1, n-3:-2:3) = count+1:2:count+2*length(n-3:-2:3)-1;
        count = count+2*length(n-3:-2:3)-1+1;
        x = false;
        
        %nach rechts: fngt bei m1-1 an
        else
        B(m1-1,3:2:n-3) = count:2:count+2*length(3:2:n-3)-2;
        B(m1,4:2:n-2) = count+1:2:count+2*length(4:2:n-2)-1;
        count = count+2*length(4:2:n-2)-1+1;
        x = true;
        end
        
        m1 = m1+2;
        
    end
    
    B(m-5,n-3) = count;
    count = count+1;
    B(m-4,n-2) = count;
    count = count+1;
    B(m-3,n-3) = count;
    count = count+1;
    B(m-2,n-2) = count;
    count = count+1;
    
    B(m-2,n-4:-2:4) = count:2:count+2*length(n-4:-2:4)-2;
    B(m-3,n-5:-2:3) = count+1:2:count+2*length(n-5:-2:3)-1;
    count = count+2*length(n-5:-2:3)-1+1;
    
    B(m-5,3:2:n-5) = count:2:count+2*length(3:2:n-5)-2;
    B(m-4,4:2:n-4) = count+1:2:count+2*length(4:2:n-4)-1;
    
    count = A(m-3,n-2)+1;
    set = B(m-4,n-4);
    
    for i = set:-1:1,
            [row,col] = find(B == i);
            B(row,col) = count;
            count = count+1;
    end
    
    A = A+B;
end
if he == true
A = rot90(A);
end