function A = numbering_matrix_one_specialcases(m,n)
% This function will give back the optimal tour for n and m with special 
% size and with radius 1 given in a matrix A.

% The special cases_see lemma7_ are implemented here:

A = zeros(m,n);
count = 1;

if m == 1 && n >= 5 && n <= 11
    if n == 5
        A = [1,4,2,5,3];
    elseif n == 6
        A = [1,5,2,4,6,3];
    elseif n == 7
        A = [1,5,2,7,3,6,4];
    elseif n == 8
        A = [1,7,2,8,4,6,3,5];
    elseif n == 9
        A = [1,8,2,9,7,5,3,6,4];
    elseif n == 10
        A = [1,9,2,10,8,3,5,7,4,6];
    elseif n == 11
        A = [1,10,2,11,9,3,8,6,4,7,5];
    end
elseif m == 1 && n > 11
    if mod(n,2) == 0
        A(m,1:2:(n-5)) = count:count+length(1:2:(n-5))-1;

        A(m,n-4:n) = [n/2+3, n/2, n/2+2, n/2-1, n/2+1];
        count = n/2+3+1;

        A(m,n-6:-2:6) = count:count+length(n-6:-2:6)-1;

        A(m,[2,4]) = [n-1,n];
    else
        A(m,1:2:(n-6)) = count:count+length(1:2:(n-6))-1;
        A(m,n-5:n) = [(n+7)/2,(n-3)/2,(n+3)/2,(n-1)/2,(n+5)/2,(n+1)/2];
        count = (n+7)/2+1;
        A(m,n-7:-2:6) = count:count+length(n-6:-2:6)-1;
        A(m,[2,4]) = [n-1,n];
    end
elseif m == 2 && n <= 8 && n >= 3
    if n == 3
        A = [1,5,3;4,2,6];
    elseif n == 4
        A = [1,6,8,3;5,2,4,7];
    elseif n == 5
        A = [1,7,10,3,9;6,2,5,8,4];
    elseif n == 6
        A = [1,10,3,9,4,7;11,2,12,6,8,5];
    elseif n == 7
        A = [1,12,3,11,7,9,6;13,2,14,4,10,5,8];
    elseif n == 8
        A = [1,14,16,12,4,8,6,9;15,2,13,3,11,5,10,7];
    end
elseif m == 2 && n > 8
    if mod(n,2) == 0
        A(1,1:2:n-3) = count:2:count+2*length(1:2:n-3)-2;
        A(2,2:2:n-4) = count+1:2:count+2*length(2:2:n-4)-1;
        count = count+2*length(1:2:n-3)-2+1;
        A(1,n-1) = count;
        A(2,n:-2:n-2) = [count+1, count+2];
        count = count+2+1;
        A(1,n:-2:4) = count:2:count+2*length(n:-2:4)-2;
        A(2,n-1:-2:5) = count+1:2:count+2*length(n-1:-2:5)-1;
        count = count+2*length(n:-2:4)-2+1;
        A(1,2) = count;
        A(2,[1,3]) = [count+1, count+2];
        
    else
        A(1,1:2:n-4) = count:2:count+2*length(1:2:n-4)-2;
        A(2,2:2:n-3) = count+1:2:count+2*length(2:2:n-3)-1;
        count = count+2*length(2:2:n-3)-1+1;
        A(2,n-1) = count;
        A(1,n:-2:n-2) = [count+1, count+2];
        count = count+2+1;
        A(2,n:-2:5) = count:2:count+2*length(n:-2:5)-2;
        A(1,n-1:-2:4) = count+1:2:count+2*length(n-1:-2:4)-1;
        count = count+2*length(n-1:-2:4)-1+1;
        A(1,2) = count;
        A(2,[1,3]) = [count+1, count+2];
        
    end
elseif m == 4
    if mod(n,2) == 1
        A([1,3],1) = [count, count+2];
        A([2,4],2) = [count+1, count+3];
        count = count+4;
        A(3,3:2:n) = count:2:count+2*length(3:2:n)-2;
        A(4,4:2:n-1) = count+1:2:count+2*length(4:2:n-1)-1;
        count = count+2*length(3:2:n)-2+1;
        A(2,n-1) = count;
        A(1,n) = count+1;
        count = count+2;
        A(1,n-2:-2:3) = count:2:count+2*length(n-2:-2:3)-2;
        A(2,n-3:-2:4) = count+1:2:count+2*length(n-3:-2:4)-1;
        count = count+2*length(n-2:-2:3)-2+1;
        
        %odd vertices:
        A(2,1:2:n) = count:2:count+2*length(1:2:n)-2;
        A(1,2:2:n-1) = count+1:2:count+2*length(2:2:n-1)-1;
        count = count+2*length(1:2:n)-2+1;
        A(3,n-1) = count;
        A(4,n) = count+1;
        count = count+2;
        A(4,n-2:-2:3) = count:2:count+2*length(n-2:-2:3)-2;
        A(3,n-3:-2:4) = count+1:2:count+2*length(n-3:-2:4)-1;
        count = count+2*length(n-2:-2:3)-2+1;
        A(4,1) = count;
        A(3,2) = count+1;
    else
        A([1,3],1) = [count, count+2];
        A([2,4],2) = [count+1, count+3];
        count = count+4;
        A(3,3:2:n-1) = count:2:count+2*length(3:2:n-1)-2;
        A(4,4:2:n) = count+1:2:count+2*length(4:2:n)-1;
        count = count+2*length(4:2:n)-1+1;
        A(2,n:-2:4) = count:2:count+2*length(n:-2:4)-2;
        A(1,n-1:-2:3) = count+1:2:count+2*length(n-1:-2:3)-1;
        count = count+2*length(n-1:-2:3)-1+1;
        %odd vertices
        A(2,1:2:n-1) = count:2:count+2*length(1:2:n-1)-2;
        A(1,2:2:n) = count+1:2:count+2*length(2:2:n)-1;
        count = count+2*length(2:2:n)-1+1;
        A(3,n:-2:4) = count:2:count+2*length(n:-2:4)-2;
        A(4,n-1:-2:3) = count+1:2:count+2*length(n-1:-2:3)-1;
        count = count+2*length(n-1:-2:3)-1+1;
        A(4,1) = count;
        A(3,2) = count+1;
    end
end

